Resolution: Fixed   

Description

Planio has developed and would like to contribute an additional toolbar button, allowing the user to insert the markup for inline code

for the supported language of her choice. Clicking the button brings up a modal window with a selector to choose which language the

markup should be for and inserts following markup in the wiki field:

<pre><code class="c">

</code>< /pre>

 (the closing < /pre> has a space because it trips the renderer otherwise).

The code is as follows (to be added to source:/trunk/public/javascripts/jstoolbar/textile.js@12152):

  // Code

  jsToolBar.prototype.elements.precode = {

    type: 'button',

    title: 'Code',

    fn: {

      wiki: function() {

        precodeTextField = this;

        var codeRayLanguages = ["c", "clojure", "cpp", "css", "delphi", "diff", "erb", "groovy", "

haml", "html", "java", "javascript", "json", "php", "python", "ruby", "sql", "text", "xml", "yaml"

];

        var languageOptions = [];

        for (var i = 0; i < codeRayLanguages.length; i++) {

          languageOptions[i] = "<option>" + codeRayLanguages[i] + "</option>";

        }

        var languageSelect = "<select>" + languageOptions.join("") + "</select>";

        var hideJs = "hideModal(this);$('#toolbar-code-options').remove();return false;";

        var questionBox = '<div id="toolbar-code-options" style="display: none"><form action="#"><

h3 class="title">Code</h3><p><label>Language ' + languageSelect + '</label></p><p class="buttons">

<input onclick="precodeTextField.encloseLineSelection(\'<pre><code class=&quot;\' + $(this).closes

t(\'div\').find(\'select\').first().val() + \'&quot;>\\n\', \'\\n</code></pre>\');'+hideJs+'" type

="submit" value="Insert Code"><input onclick="'+hideJs+'" type="button" value="Cancel"></p></form>

</div>';

        $('#main').append(questionBox);

        showModal('toolbar-code-options', '200px');

        $('#toolbar-code-options select').focus();

      }

    }

  }

 (it seems < code> is not supported here anymore or I was too dumb to use it :-/ )

Related issues:

Related to Redmine - Feature #14936: Use a stable and modifiable data structu... New

Related to Redmine - Feature #7587: jst Drop-down with syntax coloring Closed 2011-02-09

Related to Redmine - Feature #23106: Add taskpaper 'language' to new code hig... Closed
Related to Redmine - Feature #32528: Make languages in Highlighted code butto... Closed

Has duplicate Redmine - Feature #15133: Code Highlight Button or dropdown Closed

Has duplicate Redmine - Feature #13394: New "code" button integrated into iss... Closed

Associated revisions

Revision 15316 - 2016-04-10 10:44 - Jean-Philippe Lang

Inline code highlighting toolbar button (#14937).

Revision 15317 - 2016-04-10 11:13 - Jean-Philippe Lang

Adds translations for the "Highlighted code" button (#14937).

Revision 15567 - 2016-06-19 08:53 - Jean-Philippe Lang

Adds missing taskpaper language to the drop down (#14937, #23106).

Revision 15568 - 2016-06-19 08:54 - Jean-Philippe Lang

Merged r15567 (#14937, #23106).

History

#1 - 2013-09-19 05:38 - Terence Mill

+1

#2 - 2013-09-19 09:11 - Francesco V

+1

#3 - 2013-09-21 23:16 - Jan Niggemann (redmine.org team member)

Thank you, +1!

#4 - 2013-09-29 09:52 - Toshi MARUYAMA

- Related to Feature #14936: Use a stable and modifiable data structure for jsToolbar elements added

#5 - 2013-09-30 09:49 - Terence Mill

I added the block to my textile.js, butr i still see no new button? Any idea?

#6 - 2013-09-30 09:58 - Felix Schäfer

Terence, unfortunately the textile.js isn't used directly anymore but through a minified version including the toolbar code and the code for the redmine

buttons, the minified version is public/javascripts/jstoolbar/jstoolbar-textile.min.js and it's included in 

source:branches/2.3-stable/lib/redmine/wiki_formatting/textile/helper.rb#L36. You can either add the code to the minified version, or include both

jstoolbar.js and textile.js instead of jstoolbar-textile.min.js in the linked helper.

#7 - 2013-09-30 15:51 - Terence Mill

ok, now i have the button, but without any image. How can i give it an image?

Btw. Don#t forhet to mention to add locales for all languages , e.g

source#branches/2.3-stable/public/javascripts/jstoolbar/lang/jstoolbar-en.js

jsToolBar.strings['Code'] = 'Code Highlightning';

#8 - 2013-10-02 20:24 - Felix Schäfer

- File precode.diff added

- File bt_precode.png added

I have added a full diff that makes the whole thing work, please note that the change to lib/redmine/wiki_formatting/textile/helper.rb is obviously not

meant for trunk. The image for the button is also attached.

#9 - 2013-10-15 17:11 - Mischa The Evil

- Has duplicate Feature #15133: Code Highlight Button or dropdown added
#10 - 2013-10-19 08:22 - Toshi MARUYAMA

- Category set to Wiki

#11 - 2013-10-27 03:17 - Mischa The Evil

- Has duplicate Feature #13394: New "code" button integrated into issue description toolbox added

#12 - 2013-10-27 04:28 - Mischa The Evil

- Subject changed from Inline code toolbar button to Inline code highlighting toolbar button

- Target version set to Unplanned backlogs

Thanks for contributing this here. I think a lot of users can benefit from a button like this. I think it is worth a place in the core's toolbar.

Felix Schäfer wrote:

(it seems < code> is not supported here anymore or I was too dumb to use it :-/ )

 Off-topic...Off-topic...

It is still supported (rm.o isn't patched in this part AFAICT) and you are certainly not too dumb to use it :)

The highlighting is broken is this case because you've (necessarily) used the extra space before the closing < /pre>. As a result of that the renderer

ends up with an unclosed pre-tag, because its opening tag is not modded to prevent renderer triggering using an extra space, that causes the code to

be rendered w/o highlighting. This also happens with the code-tag IIRC.

I think that in this case the only - working - workaround would be something (not so good-looking ;) like:

< pre>< code class="c">

< /code>< /pre>

 

#13 - 2013-10-28 14:31 - Pedro Calvo

+1

Thank you Mischa The Evil. This feature would be a great benefit!

#14 - 2013-11-04 12:01 - Jan Jezek

I have made a plugin of the code above. Hope this helps till redmine implements this feature...

https://github.com/mediatainment/redmine_codebutton/

#15 - 2013-11-04 12:24 - Pedro Calvo

Great work, Jan!

Let's see if this little and useful plugin comes to fruition...

#16 - 2015-07-08 06:10 - Mischa The Evil

- Related to Feature #7587: jst Drop-down with syntax coloring added

#17 - 2015-12-25 03:49 - Go MAEDA

- File precode-v2.diff added

- Target version changed from Unplanned backlogs to Candidate for next major release

Very usuful!

Here is a updated patch against the current trunk (r14992). Added support for go, lua and sass.

#18 - 2015-12-25 08:57 - Go MAEDA

- File precode-v3.diff added

Added Markdown support.

#19 - 2015-12-26 05:56 - Go MAEDA
- File precode-v4.diff added

Fixed language files (en and es-PA).

diff --git a/public/javascripts/jstoolbar/lang/jstoolbar-en.js b/public/javascripts/jstoolbar/lang/jstoolbar-e

n.js

index 6427b19..4f72f08 100644

--- a/public/javascripts/jstoolbar/lang/jstoolbar-en.js

+++ b/public/javascripts/jstoolbar/lang/jstoolbar-en.js

@@ -8,7 +8,6 @@ jsToolBar.strings['Heading 1'] = 'Heading 1';

 jsToolBar.strings['Heading 2'] = 'Heading 2';

 jsToolBar.strings['Heading 3'] = 'Heading 3';

 jsToolBar.strings['Highlighted code'] = 'Highlighted code';

-jsToolBar.strings['Highlighted code'] = 'Highlighted code';

 jsToolBar.strings['Unordered list'] = 'Unordered list';

 jsToolBar.strings['Ordered list'] = 'Ordered list';

 jsToolBar.strings['Quote'] = 'Quote';

diff --git a/public/javascripts/jstoolbar/lang/jstoolbar-es-pa.js b/public/javascripts/jstoolbar/lang/jstoolba

r-es-pa.js

index 878489f..524a045 100644

--- a/public/javascripts/jstoolbar/lang/jstoolbar-es-pa.js

+++ b/public/javascripts/jstoolbar/lang/jstoolbar-es-pa.js

@@ -7,6 +7,7 @@ jsToolBar.strings['Code'] = 'Código fuente';

 jsToolBar.strings['Heading 1'] = 'Encabezado 1';

 jsToolBar.strings['Heading 2'] = 'Encabezado 2';

 jsToolBar.strings['Heading 3'] = 'Encabezado 3';

+jsToolBar.strings['Highlighted code'] = 'Highlighted code';

 jsToolBar.strings['Unordered list'] = 'Lista sin ordenar';

 jsToolBar.strings['Ordered list'] = 'Lista ordenada';

 jsToolBar.strings['Quote'] = 'Citar';

#20 - 2015-12-26 11:11 - Tobias Fischer

The plugin by Jan Jezek (https://github.com/mediatainment/redmine_codebutton/) also contains a default language selection via the plugin settings.

This would be very useful as well...

In my case, we use css and xml snippets a lot and set the default language selection to xml for not having to select the drowpdown every time...

#21 - 2016-01-19 14:53 - Go MAEDA

- File dialogbox-i18n.png added

- File precode-v5.diff added

Updated patch: precode-v5.diff

i18n for a dialog box.

 dialogbox-i18n.png 

#22 - 2016-01-19 15:17 - Go MAEDA

- Target version changed from Candidate for next major release to 3.3.0

I think this can be one of the highlights of a future release. I am setting target version to 3.3.0.

Thanks for Felix and Planio.

#23 - 2016-01-20 09:44 - Tobias Fischer

Are there any plans to add a Redmine setting for the default code language?

For details see comment 20 above...

#24 - 2016-04-10 08:44 - Jean-Philippe Lang

- File dropdown.png added

I think a modal box is a bit overkill and it makes 4 clicks to select a language. What about using a simple dropdown that is displayed when the button

is clicked ?
#25 - 2016-04-10 08:50 - Go MAEDA

Jean-Philippe Lang wrote:

I think a modal box is a bit overkill and it makes 4 clicks to select a language. What about using a simple dropdown that is displayed when the

button is clicked ?

 What you pointed out was quite right.

#26 - 2016-04-10 10:50 - Jean-Philippe Lang

- Assignee set to Jean-Philippe Lang

Thanks for the feedback. Feature added as a dropdown menu in r15316.

#27 - 2016-04-10 11:16 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Fixed

Tobias Fischer wrote:

Are there any plans to add a Redmine setting for the default code language?

 With the dropdown implementation, there's no default language. 2 clicks are needed for any language.

Most users won't use all of the languages, maybe the list could be made configurable but I think it's fine for now.

#28 - 2016-05-21 09:10 - Jean-Philippe Lang

- Subject changed from Inline code highlighting toolbar button to Code highlighting toolbar button

#29 - 2016-06-19 08:51 - Jean-Philippe Lang

- Related to Feature #23106: Add taskpaper 'language' to new code highlighting toolbar button. added

#30 - 2016-08-10 15:18 - holly chen

- File precode-are-covered.png added

The code menu was covered in my redmine.

 precode-are-covered.png 

So I just add a z-index property to fix this problem temporary.

in file jstoolbar-textile.min.js

From:

n=$("<ul style='position:absolute;'></ul>")

 To:

n=$("<ul style='position:absolute;z-index: 9999;'></ul>")

#31 - 2019-12-15 05:37 - Go MAEDA
- Related to Feature #32528: Make languages in Highlighted code button in toolbar customizable added

Files

precode.diff 34.9 KB 2013-10-02 Felix Schäfer

bt_precode.png 389 Bytes 2013-10-02 Felix Schäfer

precode-v2.diff 34.7 KB 2015-12-25 Go MAEDA

precode-v3.diff 34.7 KB 2015-12-25 Go MAEDA

precode-v4.diff 35.3 KB 2015-12-26 Go MAEDA

dialogbox-i18n.png 39 KB 2016-01-19 Go MAEDA

precode-v5.diff 52 KB 2016-01-19 Go MAEDA

dropdown.png 6.01 KB 2016-04-10 Jean-Philippe Lang

precode-are-covered.png 3.34 KB 2016-08-10 holly chen
